# KNP optimality ([]Maculan, Michelon, Smith 95] with beta correction)

param n integer, >= 1;  # used as an upper bound in this formulation
param K integer, >= 1;

set N := 1..n;  
set Dim := 1..K;

param xbar{N,Dim};

var x{N,Dim} >= -1, <= 1;
var a{N} binary;

maximize slacks: sum{i in N} a[i];

subject to norm{i in N}: sum{k in Dim} x[i,k]^2 = 1;
subject to dist{i in N, j in N : i < j}:
  sum{k in Dim} (x[i,k] - x[j,k])^2 >= a[i]+a[j]-1;

